import { Schema, StringValue } from "@coveo/bueno";
import { buildInteractiveResult, buildResultList, buildResultsPerPage } from "@coveo/headless/insight";
import { LitElement, html } from "lit";
import { customElement, property, state } from "lit/decorators.js";
import { keyed } from "lit/directives/keyed.js";
import { map } from "lit/directives/map.js";
import { ref } from "lit/directives/ref.js";
import { when } from "lit/directives/when.js";
import { renderItemPlaceholders } from "../../common/atomic-result-placeholder/item-placeholders.js";
import { createAppLoadedListener } from "../../common/interface/store.js";
import { renderDisplayWrapper } from "../../common/item-list/display-wrapper.js";
import { renderItemList } from "../../common/item-list/item-list.js";
import { ItemListCommon } from "../../common/item-list/item-list-common.js";
import { ResultTemplateProvider } from "../../common/item-list/result-template-provider.js";
import placeholders_tw_css from "../../common/item-list/styles/placeholders.tw.css.js";
import { getItemListDisplayClasses } from "../../common/layout/item-layout-utils.js";
import { ValidatePropsController } from "../../common/validate-props-controller/validate-props-controller.js";
import { bindStateToController } from "../../../decorators/bind-state.js";
import { bindingGuard } from "../../../decorators/binding-guard.js";
import { bindings } from "../../../decorators/bindings.js";
import { errorGuard } from "../../../decorators/error-guard.js";
import { withTailwindStyles } from "../../../decorators/with-tailwind-styles.js";
import { ChildrenUpdateCompleteMixin } from "../../../mixins/children-update-complete-mixin.js";
import { FocusTargetController } from "../../../utils/accessibility-utils.js";
import { randomID } from "../../../utils/utils.js";
import insight_list_display_tw_css from "./insight-list-display.tw.css.js";
import "../atomic-insight-result/atomic-insight-result.js";
import "../atomic-insight-result-template/atomic-insight-result-template.js";
function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : null === desc ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if ("object" == typeof Reflect && "function" == typeof Reflect.decorate) r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if ("object" == typeof Reflect && "function" == typeof Reflect.metadata) return Reflect.metadata(k, v);
}
class AtomicInsightResultList extends ChildrenUpdateCompleteMixin(LitElement) {
    async setRenderFunction(resultRenderingFunction) {
        this.itemRenderingFunction = resultRenderingFunction;
    }
    initialize() {
        this.resultList = buildResultList(this.bindings.engine, {
            options: {
                fieldsToInclude: this.bindings.store.state.fieldsToInclude || void 0
            }
        });
        this.resultsPerPage = buildResultsPerPage(this.bindings.engine);
        this.initResultTemplateProvider();
        this.initResultListCommon();
        createAppLoadedListener(this.bindings.store, (isAppLoaded)=>{
            this.isAppLoaded = isAppLoaded;
        });
    }
    async willUpdate(changedProperties) {
        super.willUpdate(changedProperties);
        if (changedProperties.has('resultListState')) {
            const oldState = changedProperties.get('resultListState');
            if (this.resultListState.firstSearchExecuted) this.bindings.store.unsetLoadingFlag(this.loadingFlag);
            if (!oldState?.isLoading && this.resultListState.isLoading) this.isEveryResultReady = false;
        }
        await this.updateResultReadyState();
    }
    get shouldMarkResultsAsReady() {
        return this.isAppLoaded && !this.isEveryResultReady && this.resultListState?.firstSearchExecuted && this.resultListState?.results?.length > 0;
    }
    async updateResultReadyState() {
        if (this.shouldMarkResultsAsReady) {
            await this.getUpdateComplete();
            this.isEveryResultReady = true;
        }
    }
    render() {
        return html`${renderItemList({
            props: {
                hasError: this.resultListState.hasError,
                hasItems: this.resultListState.hasResults,
                hasTemplate: this.resultTemplateRegistered,
                firstRequestExecuted: this.resultListState.firstSearchExecuted,
                templateHasError: this.templateHasError
            }
        })(html`${when(this.templateHasError, ()=>html`<slot></slot>`, ()=>{
            this.resultListCommon.updateBreakpoints();
            const listClasses = this.computeListDisplayClasses();
            const resultClasses = `${listClasses} ${!this.isEveryResultReady && 'hidden'}`;
            return html`
            ${when(this.isAppLoaded, ()=>renderDisplayWrapper({
                    props: {
                        listClasses: resultClasses,
                        display: this.display
                    }
                })(html`${this.renderList()}`))}
            ${when(!this.isEveryResultReady, ()=>renderDisplayWrapper({
                    props: {
                        listClasses,
                        display: this.display
                    }
                })(renderItemPlaceholders({
                    props: {
                        density: this.density,
                        display: this.display,
                        imageSize: this.imageSize,
                        numberOfPlaceholders: this.resultsPerPageState.numberOfResults || 10
                    }
                })))}
          `;
        })}`)}`;
    }
    initResultTemplateProvider() {
        this.resultTemplateProvider = new ResultTemplateProvider({
            includeDefaultTemplate: true,
            templateElements: Array.from(this.querySelectorAll('atomic-insight-result-template')),
            getResultTemplateRegistered: ()=>this.resultTemplateRegistered,
            getTemplateHasError: ()=>this.templateHasError,
            setResultTemplateRegistered: (value)=>{
                this.resultTemplateRegistered = value;
            },
            setTemplateHasError: (value)=>{
                this.templateHasError = value;
            },
            bindings: this.bindings
        });
    }
    initResultListCommon() {
        this.resultListCommon = new ItemListCommon({
            engineSubscribe: this.bindings.engine.subscribe,
            getCurrentNumberOfItems: ()=>this.resultListState.results.length,
            getIsLoading: ()=>this.resultListState.isLoading,
            host: this,
            loadingFlag: this.loadingFlag,
            nextNewItemTarget: this.focusTarget,
            store: this.bindings.store
        });
    }
    computeListDisplayClasses() {
        const displayPlaceholders = !(this.isAppLoaded && this.isEveryResultReady);
        return getItemListDisplayClasses(this.display, this.density, this.imageSize, this.resultListState?.isLoading, displayPlaceholders);
    }
    renderList() {
        return html`${map(this.resultListState.results, (result, index)=>html`${keyed(this.getResultId(result), html`<atomic-insight-result
          part="outline"
          ${ref((element)=>element instanceof HTMLElement && this.resultListCommon.setNewResultRef(element, index))}
          .content=${this.resultTemplateProvider.getTemplateContent(result)}
          .density=${this.density}
          .display=${this.display}
          .imageSize=${this.imageSize}
          .interactiveResult=${this.getInteractiveResult(result)}
          .loadingFlag=${this.loadingFlag}
          .result=${result}
          .renderingFunction=${this.itemRenderingFunction}
          .store=${this.bindings.store}
        ></atomic-insight-result>`)}`)}`;
    }
    get focusTarget() {
        if (!this.nextNewResultTarget) this.nextNewResultTarget = new FocusTargetController(this, this.bindings);
        return this.nextNewResultTarget;
    }
    getInteractiveResult(result) {
        return buildInteractiveResult(this.bindings.engine, {
            options: {
                result
            }
        });
    }
    getResultId(result) {
        return this.resultListCommon.getResultId(result.uniqueId, this.resultListState.searchResponseId, this.density, this.imageSize);
    }
    constructor(){
        super(), this.loadingFlag = randomID('firstInsightResultLoaded-'), this.display = 'list', this.isAppLoaded = false, this.isEveryResultReady = false, this.resultTemplateRegistered = false, this.templateHasError = false, this.density = 'normal', this.imageSize = 'icon';
        new ValidatePropsController(this, ()=>({
                density: this.density,
                imageSize: this.imageSize
            }), AtomicInsightResultList.propsSchema);
    }
}
AtomicInsightResultList.styles = [
    placeholders_tw_css,
    insight_list_display_tw_css
];
AtomicInsightResultList.propsSchema = new Schema({
    density: new StringValue({
        constrainTo: [
            'normal',
            'comfortable',
            'compact'
        ]
    }),
    imageSize: new StringValue({
        constrainTo: [
            'small',
            'large',
            'icon',
            'none'
        ]
    })
});
_ts_decorate([
    state(),
    _ts_metadata("design:type", "u" < typeof InsightBindings ? Object : InsightBindings)
], AtomicInsightResultList.prototype, "bindings", void 0);
_ts_decorate([
    state(),
    _ts_metadata("design:type", "u" < typeof Error ? Object : Error)
], AtomicInsightResultList.prototype, "error", void 0);
_ts_decorate([
    state()
], AtomicInsightResultList.prototype, "isAppLoaded", void 0);
_ts_decorate([
    state()
], AtomicInsightResultList.prototype, "isEveryResultReady", void 0);
_ts_decorate([
    state()
], AtomicInsightResultList.prototype, "resultTemplateRegistered", void 0);
_ts_decorate([
    state()
], AtomicInsightResultList.prototype, "templateHasError", void 0);
_ts_decorate([
    bindStateToController('resultList'),
    state(),
    _ts_metadata("design:type", "u" < typeof InsightResultListState ? Object : InsightResultListState)
], AtomicInsightResultList.prototype, "resultListState", void 0);
_ts_decorate([
    bindStateToController('resultsPerPage'),
    state(),
    _ts_metadata("design:type", "u" < typeof InsightResultsPerPageState ? Object : InsightResultsPerPageState)
], AtomicInsightResultList.prototype, "resultsPerPageState", void 0);
_ts_decorate([
    property({
        reflect: true,
        type: String
    }),
    _ts_metadata("design:type", "u" < typeof ItemDisplayDensity ? Object : ItemDisplayDensity)
], AtomicInsightResultList.prototype, "density", void 0);
_ts_decorate([
    property({
        reflect: true,
        attribute: 'image-size',
        type: String
    }),
    _ts_metadata("design:type", "u" < typeof ItemDisplayImageSize ? Object : ItemDisplayImageSize)
], AtomicInsightResultList.prototype, "imageSize", void 0);
_ts_decorate([
    bindingGuard(),
    errorGuard(),
    _ts_metadata("design:type", Function),
    _ts_metadata("design:paramtypes", []),
    _ts_metadata("design:returntype", void 0)
], AtomicInsightResultList.prototype, "render", null);
AtomicInsightResultList = _ts_decorate([
    customElement('atomic-insight-result-list'),
    bindings(),
    withTailwindStyles,
    _ts_metadata("design:type", Function),
    _ts_metadata("design:paramtypes", [])
], AtomicInsightResultList);
export { AtomicInsightResultList };
